﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
' Type Reg_Sincro(nomTabla As String, fechaHora As String)
 
 Dim listaSincronizacion As List
 Dim listaSincronizacionB As List
 Dim miFtp As FTP
 Dim rutaBBDD As String = File.DirRootExternal & "/BDDocs/"
  
 
' Dim registro As Reg_Sincro

End Sub

Sub ExisteTabla(tableName As String,bdbsql As SQL) As Boolean
	
	If bdbsql.ExecQuerySingleResult("SELECT count(name) FROM sqlite_master WHERE type='table' AND name = '" & tableName & "'") = 0 Then
	 	Return False
	Else
	 	Return True
	End If
End Sub


Sub CreacionTablasExtra(bdbsql As SQL) 
	Log(" Creacion Tabla Fotografias ")
	Try		
	    bdbsql.ExecNonQuery("CREATE TABLE Fotografias (id INT PRIMARY KEY NOT NULL ,idMatriculaLeida INT  NOT NULL ,idUsuario INT  NOT NULL, PathFotografia VARCHAR(256)  NULL DEFAULT NULL,ULT_TIMESTAMP DATETIME  NULL DEFAULT NULL)")		
	Catch		
		Msgbox("Fatal Error: " & LastException.Message, "TMG Plate Reader - Messages")
	End Try
End Sub

Sub Inicializacion_DB(bdbsql As SQL, nombre As String)


Dim pm As PackageManager 
Dim AppVers As String
AppVers = pm.GetVersionName("tmg.carplatereader")

	Log("BBDD: " & File.DirAssets & "/" & nombre)
    If File.Exists(File.DirRootExternal & "/TMGFS/",nombre) = False Then
		If File.Exists(File.DirRootExternal& "/TMGFS/","") = False Then 
			File.MakeDir(File.DirRootExternal,"/TMGFS")
			File.Copy(File.DirAssets, nombre, File.DirRootExternal& "/TMGFS/", nombre)
		Else
			' Si la versión es la v1.0.0 borramos antes la BBDD 			
        		File.Copy(File.DirAssets, nombre, File.DirRootExternal& "/TMGFS/", nombre)			
		End If
	Else
		' Si la versión es la v1.0.0 machacamos la BBDD con la nueva version 			
		If AppVers="1.0.0" Then 
			File.Copy(File.DirAssets, nombre, File.DirRootExternal& "/TMGFS/", nombre)	
		End If		
    End If	
    bdbsql.Initialize(File.DirRootExternal& "/TMGFS/", nombre, False)		
	' Propagamos el nuevo cambio
	If Not(ExisteTabla("Fotografias",bdbsql)) Then 
		CreacionTablasExtra(bdbsql)
	End If
End Sub

Sub Inicializacion_BBDocs
If File.Exists(rutaBBDD,"") = False Then 
	File.MakeDir(File.DirRootExternal, "/BDDocs")
End If
End Sub


Sub Ini_ListaSinc
	Dim c As Cursor
	' Inicializamos todas las tablas maestras tipo=M a descargar.
	listaSincronizacion.Initialize
	c = Main.bdbsql.ExecQuery("SELECT Nombre_Tabla, ULT_TIMESTAMP FROM tablas_sincronizacion where tipo_tabla='M' ORDER BY orden")
	For i = 0 To c.RowCount - 1
	'	registro.Initialize
		c.Position = i
		Log("Añadiendo tabla tipo M:"& c.GetString("Nombre_Tabla"))
		Log("Añadiendo tabla tipo M:"& c.GetString("ULT_TIMESTAMP"))
		listaSincronizacion.Add(c.GetString("Nombre_Tabla"))
		' cuando desdoblemos 
	'	registro.nomTabla = c.GetString("Nombre_Tabla")
	'	registro.fechaHora = c.GetString("ULT_TIMESTAMP")
	'	listaSincronizacion.Add(registro)
	Next
	c.close
End Sub

Sub Valida_Usuario(pUserName As String, pPassWord As String) As Boolean 
	Dim c As Cursor
	c=Main.bdbsql.ExecQuery("SELECT id,Nombre,Apellidos,Tipo_Usuario_id FROM USUARIO WHERE login='" & pUserName & "' AND password='" & pPassWord & "'" )

	If c.RowCount >0 Then 
		' JLP: 14-11-2012
		' Recogemos los datos del usuario porque los usaremos por toda la App
		'
		c.Position=0
		Login.idUsuarioConectado = c.GetString("id")
		Login.nombreConectado = c.GetString("Nombre")
		Login.apellidoConectado = c.GetString("Apellidos")
		Login.TipoUsuarioId = c.GetString("Tipo_Usuario_id")
		
		Log("idUsuarioConectado=" & Login.idUsuarioConectado)
		Log("apellidoConectado=" & Login.apellidoConectado)
		Log("TipoUsuarioId=" & Login.TipoUsuarioId)
		
		
		Return True
	Else
		Return False
	End If
End Sub

Sub Ultima_Sincronizacion As String
	Dim c As Cursor
	Dim valor As String
	
	c=Main.bdbsql.ExecQuery("SELECT MAX(Fecha_Sincronizacion) AS sinc FROM Log_Sincronizacion")
	If c.RowCount>0 Then 
		c.Position=0
		valor=c.GetString("sinc")	
		c.Close
		Return valor
		
	Else	
		c.Close
		Return "1980-01-01 00:00:00"
		
	End If

End Sub 

Sub Ultima_Sincronizacion_Tabla(nombreTablas As String) As String
	Dim c As Cursor
	Dim retorno As String
	
	c=Main.bdbsql.ExecQuery("SELECT MAX(Fecha_Sincronizacion) AS sinc FROM Log_Sincronizacion L INNER JOIN tablas_sincronizacion T ON L.tablas_sincronizacion_id = T.id WHERE T.Nombre_Tabla='" & nombreTablas & "'")
	If c.RowCount>0 Then 
		c.Position=0
		retorno = c.GetString("sinc")
		c.Close			
		If retorno=Null Then 			
			Log("Ult. sincronizacion: 1980-01-01 00:00:00")
			Return "1980-01-01 00:00:00"
		Else			
			Log("Ult. sincronizacion: "&retorno)
			Return retorno	
		End If 		
	Else
		c.Close
		Return "1980-01-01 00:00:00"		
	End If

End Sub 

Sub Ini_ListaSincTablasB
	Dim c As Cursor
	' Inicializamos todas las tablas maestras tipo=B a descargar.
	listaSincronizacionB.Initialize
	c = Main.bdbsql.ExecQuery("SELECT Nombre_Tabla, ULT_TIMESTAMP FROM tablas_sincronizacion where tipo_tabla='B' ORDER BY orden")
	For i = 0 To c.RowCount - 1
		c.Position = i
		Log("Añadiendo tabla tipo B:"& c.GetString("Nombre_Tabla"))
		Log("Añadiendo tabla tipo B:"& c.GetString("ULT_TIMESTAMP"))
		listaSincronizacionB.Add(c.GetString("Nombre_Tabla"))
	Next
	c.close
End Sub


Sub miFTP_DownloadCompleted (ServerPath As String, Success As Boolean)
Log(ServerPath & ", Success=" & Success)
If Success = False Then Msgbox(LastException.Message,"")
End Sub


Sub IdMatriculaLeidaNextVal As Int
' Login.idUsuarioConectado*10000 + 1
Dim c As Cursor
Dim result As Int

c = Main.bdbsql.ExecQuery("SELECT MAX(id)+1 As NextId FROM Matriculas_Leidas WHERE idUsuario = "& Login.idUsuarioConectado)
If c.RowCount > 0 Then 
 c.Position = 0
 result = c.GetInt("NextId")
	If result=0 Then 
		' Es la primera vez 
		Return Login.idUsuarioConectado*10000
	Else
		Return c.GetInt("NextId")
	End If
End If
End Sub

Sub Guarda_Matricula(pNumber As String, pLatitud As Float, pLongitud As Float, pIdEstado As Int, pComentarios As String, pPais As String, pRegion As String, pProvincia As String, pPoblacion As String, pDireccion As String, pIdMarca As Int, pIdModelo As Int, pIdUsState As Int, pVIN As String, pPlateExp As String, pViolationTypeId As Int, pPcode As String,pFine As String) As Int
' ** SELECT id,Plate_number,idUsuario,Latitud,Longitud,idEstado,Comentarios,Fecha_Alta

Dim idLectura As Int = IdMatriculaLeidaNextVal 
Dim now As Long = DateTime.now
Dim auxFechaLectura As String

DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss" ' 
auxFechaLectura = DateTime.Date(now)
If (pNumber="") OR (pNumber="VPARNOTRUNNING") Then 
	pNumber = "T1792AT"
End If
Main.bdbsql.ExecNonQuery2("INSERT INTO Matriculas_Leidas VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",Array As Object(idLectura,pNumber,Login.idUsuarioConectado,pLatitud,pLongitud,pIdEstado,pComentarios,auxFechaLectura, pPais, pRegion, pProvincia, pPoblacion, pDireccion, auxFechaLectura, pIdMarca,pIdModelo,pIdUsState,pVIN, pPlateExp,pViolationTypeId,pPcode,pFine))
Return idLectura
End Sub

Sub IdFotografiaNextVal As Int
' Login.idUsuarioConectado*10000 + 1
Dim c As Cursor
Dim result As Int

c = Main.bdbsql.ExecQuery("SELECT MAX(id)+1 As NextId FROM Fotografias WHERE idUsuario = "& Login.idUsuarioConectado)
If c.RowCount > 0 Then 
 c.Position = 0
 result = c.GetInt("NextId")
	If result=0 Then 
		' Es la primera vez 
		Return Login.idUsuarioConectado*10000
	Else
		Return c.GetInt("NextId")
	End If
End If
End Sub

Sub Guarda_Fotografia(pIdMatriculaLeida As Int, pPathFoto As String) As Int
 Dim idLectura As Int = IdFotografiaNextVal 
 Dim now As Long = DateTime.now
 Dim auxFechaLectura As String

	DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss" ' 
	auxFechaLectura = DateTime.Date(now)	
	Main.bdbsql.ExecNonQuery2("INSERT INTO Fotografias VALUES(?,?,?,?,?)",Array As Object(idLectura, pIdMatriculaLeida,Login.idUsuarioConectado,pPathFoto,auxFechaLectura))
	Return idLectura
End Sub
