﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
'*----------------------------------------------------------------------------------------------------
'* JLP: 10-11-2012
' En esta pantalla sincronizamos todas las tablas maestras para repartir el trabajo de sincronización
' y solo dejar las de la visita al cerrar la visita
' En la sincronización global se hará todo el proceso completo
'*----------------------------------------------------------------------------------------------------
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim job,job2 As HttpJob
	Dim posTablaEnSinc As Int
	Dim idUsuarioConectado As Int
	Dim TipoUsuarioId As Int
	Dim nombreConectado As String
	Dim apellidoConectado As String
	Dim loginConectado As String
	
			
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim Button1 As Button
	Dim PassWord As EditText
	Dim UserName As EditText
	Dim RobotoCondensedItalic As Typeface
	Dim SignikaBold  As Typeface
	Private Label3 As Label
	Dim p As Phone
	' Analytics
	Dim tracker As AnalyticsTracker
	Private Help As Panel
	
	Private Label4 As Label
	Private Label5 As Label
	Private Label6 As Label
End Sub


Sub DisableAutoSuggest
' Desactivamos autosuggest en el campo password
	PassWord.InputType= Bit.OR(PassWord.InputType, 0x00000080)
End Sub

Sub DisableHelpCredentials
	If Help.IsInitialized Then 
		Help.Width = 1dip
		Help.Height = 1dip
		Help.Visible = False
		Help.Enabled = False
	End If 		
End Sub
'
'Sub SetHints
'	UserName.Hint = "Type here your username ...."
'	PassWord.Hint = "Type here your password ..."
'End Sub
'
'Sub DisableHints
'	UserName.Hint = ""
'	PassWord.Hint = ""
'End Sub

Sub Activity_Create(FirstTime As Boolean)
Dim b As Boolean
	RobotoCondensedItalic  = Typeface.LoadFromAssets("Roboto-CondensedItalic.ttf")	
	If Sincronizacion.ExisteConexion Then 		
		BaseDatos.Inicializacion_DB(Main.bdbsql,"carplatereader.db")		
		Parameters.RecuperaParametros
		' Inicia sincronizacion
		ProgressDialogShow("Loading ...")
		' Antes de borrar el log de sincronizacion recuperamos cuando fue el ultimo momento
		Main.ultimaSincronizacion = BaseDatos.Ultima_Sincronizacion
		'Main.bdbsql.ExecNonQuery("DELETE FROM Log_Sincronizacion")
		'Descargamos tablas_sincronizacion que es la tabla que controla todo el proceso		
		job2.Initialize("PrimeraTabla",Me)
		b=Sincronizacion.DescargaPrimeraTabla
		Select b
			Case False 
				Msgbox("Error:" & LastException, "TMG Plate Reader - Messages")
				Activity.Finish			
		End Select
	 Else
		Msgbox("You need a Data Connection", "TMG Plate Reader - Messages")
		Activity.Finish
	End If
	' Modo portrait
 	p.SetScreenOrientation(1)
	'DisableHelpCredentials			
End Sub

Sub RestoTablas 
	'Sincronizar_TablasDescarga tipo=M
	' Inicializamos la lista de sincronizacion a partir de la posicion 0
	posTablaEnSinc = 0 
	job.Initialize("Sincronizar",Me)
	BaseDatos.Ini_ListaSinc
	DescargarDatos(BaseDatos.listaSincronizacion.Get(posTablaEnSinc))
	ProgressDialogHide
End Sub


Sub Activity_Resume
	tracker.Start
	DisableHelpCredentials
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	tracker.Stop
	DisableHelpCredentials
End Sub

Sub Activity_Touch (Action As Int, X As Float, Y As Float)

End Sub

Sub Button1_Click
' Validar usuario y contraseña

Dim pCypherPassWord As String

 If UserName.Text ="" OR PassWord.Text ="" Then 
	ToastMessageShow("You need to type a valid username and password",False) 
	UserName.RequestFocus 'Volvemos a posicionar en el campo de Username
	UserName.Color = Colors.Gray
	PassWord.Color = Colors.Gray
 Else
    ' Encriptar el password introducido a ver si coincide con el de la BBDD
    pCypherPassWord = Encriptacion.EncriptarMD5(PassWord.Text)
	If BaseDatos.Valida_Usuario(UserName.Text,pCypherPassWord) Then 
	' Registramos tambien el loginConectado
		loginConectado = UserName.Text
		tracker.TrackEvent("Login","Conexión", "Conexión Correcta",1)	
		tracker.Dispatch
		Activity.Finish
	Else
		ToastMessageShow("Incorrect username or password ",False)
		UserName.RequestFocus
		UserName.Color = Colors.Gray
		PassWord.Color = Colors.Gray
		tracker.TrackEvent("Login","Conexión", "Conexión Incorrecta",0)
		tracker.Dispatch
		' Activity.Finish
	End If
 End If
End Sub

Sub DescargarDatos(tabla As String)
		Try
				Main.tablaComunicaciones = tabla
				job.Download2(Main.url, Array As String("tabla",tabla, "format","json"))
		Catch
			Log(LastException.Message)
			Msgbox("Error connecting to:" & Main.url,"TMG Plate Reader - Mensajes Error")
			Activity.Finish
		End Try				
End Sub

Sub JobDone (pJob As HttpJob)
' Gestiona todos los HTTP Jobs lanzados cuando acaban.

	Dim result As String
    Log("JobName = " & pJob.JobName & ", Success = " & pJob.Success)
    If pJob.Success = True Then
        Select pJob.JobName
            Case "Sincronizar"
                ' Procesamos los resultados cada vez que acaba un job
				' Sacamos de la tabla listaSincronización la siguiente tabla a sincronizar
				result = pJob.GetString
				Log("Salida:" & result)
				If posTablaEnSinc < BaseDatos.listaSincronizacion.Size Then 
					Log("Tabla a parsear:" & Main.tablaComunicaciones)
					Sincronizacion.ParsearDatosTablas(result)
					posTablaEnSinc = posTablaEnSinc + 1
					If posTablaEnSinc < BaseDatos.listaSincronizacion.Size Then
						DescargarDatos(BaseDatos.listaSincronizacion.Get(posTablaEnSinc))
					End If
				End If		
				' Solo cuando acaben todas las tablas mostramos el login
				Activity.LoadLayout("Login")
				' Inicializacion
				SignikaBold  = Typeface.LoadFromAssets("Signika-Bold.ttf")
				Label3.Typeface = SignikaBold
				UserName.RequestFocus				
				ProgressDialogHide
				'SetHints
				
            Case "PrimeraTabla"
				' Solo en el caso de descarga inicial de tablas_sincronizacion
				result = pJob.GetString
				Log("Salida:" & result)
                Sincronizacion.ParsearDatosTablas(result)
				RestoTablas				
        End Select
    Else
        Log("Error: " & pJob.ErrorMessage)
        ToastMessageShow("Error: " & pJob.ErrorMessage, True)
    End If
    pJob.Release
End Sub

Sub Activity_KeyPress (key As Int) As Boolean
'    If key=KeyCodes.KEYCODE_BACK Then
'    	Return True 
'    End If
	
	Select key
		Case KeyCodes.KEYCODE_BACK, KeyCodes.KEYCODE_HOME, KeyCodes.KEYCODE_MENU
			Return True
	End Select	
End Sub

Sub Button2_Click
	Activity.Finish
End Sub

Sub PassWord_FocusChanged (HasFocus As Boolean)
	If HasFocus Then 
		' Desactivar el autosuggest en el campo password
		'PassWord.Hint =""
		DisableAutoSuggest
	End If
End Sub


Sub btnClose_Click		
	Help.Enabled = False	
	Help.Visible = False
End Sub

Sub askHelp_Click
	Help.Enabled = True
	Help.Visible = True
End Sub

'
'Sub UserName_FocusChanged (HasFocus As Boolean)
'	If HasFocus Then 
'		UserName.Hint =""
'	End If	
'End Sub


