﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals	
	Type GeneralParams (urlEnvio As String, urlDescarga As String, urlVPAR As String, countryCode As Int,urlEnvioFoto As String)
	Dim parametrosGlobalesApp As GeneralParams
End Sub


Sub setUrlEnvio(pUrlEnvio As String)
	If pUrlEnvio<>"" Then 
		parametrosGlobalesApp.urlEnvio = pUrlEnvio
	End If
End Sub

Sub setUrlDescarga(pUrlDescarga As String)
	If pUrlDescarga<>"" Then 
		parametrosGlobalesApp.urlDescarga = pUrlDescarga
	End If
End Sub


Sub setUrlVPAR(pUrlVPAR As String)
	If pUrlVPAR<>"" Then 
		parametrosGlobalesApp.urlVPAR = pUrlVPAR
	End If
End Sub

Sub setCountryCode(pCountryCode As Int)
	If pCountryCode<>0 Then 
		parametrosGlobalesApp.CountryCode = pCountryCode
	End If
End Sub

Sub setUrlEnvioFoto(pUrlEnvioFoto As String)
	If pUrlEnvioFoto<>"" Then 
		parametrosGlobalesApp.urlEnvioFoto = pUrlEnvioFoto
	End If
End Sub

Sub getUrlEnvio As String
	Return parametrosGlobalesApp.urlEnvio
End Sub

Sub getUrlDescarga As String
	Return parametrosGlobalesApp.urlDescarga
End Sub

Sub getUrlVPAR As String
	Return parametrosGlobalesApp.urlVPAR
End Sub

Sub getCountryCode As Int
	Return parametrosGlobalesApp.countryCode
End Sub

Sub getUrlEnvioFoto As String
	Return parametrosGlobalesApp.urlEnvioFoto
End Sub 

Sub GuardarParametros
' Guardamos en BBDD los parametros
	Main.bdbsql.ExecNonQuery2("UPDATE Configuracion SET Value=? WHERE Name='urlEnvio'",Array As Object(parametrosGlobalesApp.urlEnvio))
	Main.bdbsql.ExecNonQuery2("UPDATE Configuracion SET Value=? WHERE Name='url'",Array As Object(parametrosGlobalesApp.urlDescarga))
	Main.bdbsql.ExecNonQuery2("UPDATE Configuracion SET Value=? WHERE Name='paisLectura'",Array As Object(parametrosGlobalesApp.countryCode))		
End Sub

Sub RecuperaParametros
' Recuperamos de la BBDD los parametros
 Dim consulta As String="SELECT Name, Value FROM Configuracion"
 Dim C As Cursor
 
 	C = Main.bdbsql.ExecQuery(consulta)
	For i = 0 To C.RowCount - 1
		C.Position = i
		Select C.GetString("Name")
			Case "urlEnvio"
				setUrlEnvio(C.GetString("Value"))
			Case "url"
				setUrlDescarga(C.GetString("Value"))
			Case "urlVPAR"
				setUrlVPAR(C.GetString("Value"))
			Case "paisLectura"
				setCountryCode(C.GetInt("Value"))
			Case "urlEnvioFoto" 		
				setUrlEnvioFoto(C.GetString("Value"))
		End Select
	Next
 	C.Close
End Sub

Sub ConfiguracionInicializada As Boolean
 Dim consulta As String="SELECT COUNT(*) AS numero FROM Configuracion"
 Dim c As Cursor
 Dim valor As Int
 
 
 	c = Main.bdbsql.ExecQuery(consulta)
	If c.RowCount > 0 Then
		c.Position = 0 ' Nos posicionamos en el primer registro del resultado
		valor = c.GetInt("numero")
		c.Close
		Return (valor=6) ' Tiene 6 parámetros el sistema actualmente
	Else
		c.close
		Return False
	End If

End Sub

Sub GetCountryName(countryCode As Int) As String
' Recuperamos de la BBDD los parametros
 Dim consulta As String="SELECT descripcion FROM Country_Code WHERE id=" & countryCode 
 Dim C As Cursor
 Dim valor As String
 
 
 	C = Main.bdbsql.ExecQuery(consulta)
	If C.RowCount > 0 Then
		C.Position = 0 ' Nos posicionamos en el primer registro del resultado
		valor = C.GetString("descripcion")
		C.Close
		Return valor
	Else
		C.close
		Return "No valid Country"
	End If
End Sub

